<?php
class especial_Model_DbTable_Clienteodonto extends Zsam_Db_Table {


    protected $_name 	= 'clienteodonto';
    var $_autocomplet 	= array('CODIGO', 'NOME', 'FANTASIA', 'CNPJ');
    private $config;

    var $_conf = array(
        
        "CODIGO" 					=> array("grid" => true, 'width' => 1 /* cada unidade representa 50px */, "edit" => "N", 'NULLABLE' => false, 'help' => 'help_cod'),
        "NOME" 						=> array("grid" => true, 'width' => 4, 'NULLABLE' => false, 'title' => 'razao_social'),
        "FANTASIA" 					=> array("grid" => true, 'width' => 6),
        "AVALIACAO" 				=> array('VP' => array('1' => 'Clie', '2' => 'Recept', '3' => 'N_recp_N', '4' => 'Msg', '5' => 'N_q_falar', '6' => 'N_aten', '7' => 'telErrado', '8' => 'cadAlguem', '9' => 'inic')),
        "REGIAO" 					=> array('VP' => array('C' => 'Cent', 'N' => 'Nort', 'D' => 'Nord', 'S' => 'Sul', 'T' => 'SuldT', 'L' => 'Les', 'O' => 'Oest', 'R' => 'Noroest', 'U' => 'Suldoest')),
        "FORMA_ABORDAGEM" 			=> array('alt' => 'alt_desc_formaAbord'),
        "POTENCIAL_COMPRA" 			=> array('VP' => array('A' => 'alto', 'M' => 'medio', 'B' => 'baixo'), 'grid' => true),
        "LIMITE_CREDITO" 			=> array('NULLABLE' => false, 'editlevel' => 4),
        "LIMITE_CREDITO_DISONIVEL" 	=> array("edit" => "N"),
        "BLOQUEIO_FATURA" 			=> array("edit" => "N"),
        "CNPJ" 						=> array("grid" => true, 'help' => 'help_cnpj', 'validate' => array('Zsam_Validate_Cp')),
        "INDICADOR_IE"				=> array("VP" => array('1' => 'contribuinte_do_icms', '2' => 'contribuinte_isento', '3' => 'nao_contribuinte')),
		"IE" 						=> array('validate' => array('Cisweb_Validate_Inscricaoest'), "help" => "help_cnpj"),
        "INSCRICAO_MUNICIPAL" 		=> array(),
        "REPRESENTANTE_LEGAL" 		=> array('help' => 'help_representante_legal','case'=>'NONE','char_spec'=>'NONE'),
        "ISS" 						=> array(),
        "RETENCAO_ISS" 				=> array('VP' => array('N' => 'semretencao', 'S' => 'comretencao')),
        "ALIQUOTA_ICMS_DENTRO_ESTADO" => array("edit" => "N"),
		"ALIQUOTA_ICMS_FORA_ESTADO"	=> array("edit" => "N"),
		"ENDERECO" 					=> array('NULLABLE' => false),
        "COMPLEMENTO" 				=> array(),
        "NUMERO_ENDERECO" 			=> array('NULLABLE' => false),
        "BAIRRO" 					=> array('NULLABLE' => false),
        "CEP" 						=> array('NULLABLE' => false, 'help' => 'help_cep'),
        "CEP1" 						=> array('NULLABLE' => false, 'help' => 'help_cep2'),
        'CIDADE' 					=> array('autocomplete' => 'Y', 'NULLABLE' => false, 'grid' => true),
        "ESTADO"					=> array("edit" => "N"),
		'REFERENCIA' 				=> array('title' => 'ponto_referencia'),
        "END_COB" 					=> array(),
		"COMPLEMENTO_COB"			=> array("edit" => "N"),
        "NUMERO_END_COB" 			=> array('title' => 'NUMERO_ENDERECO'),
        "BAI_COB" 					=> array('title' => 'BAIRRO'),
        "CIDADE_COB" 				=> array('autocomplete' => 'Y', 'title' => 'CIDADE', 'alt' => 'alt_desc_cidade'),
        "CEP_COB" 					=> array('title' => 'CEP', 'help' => 'help_cep'),
        "CEP_COB1" 					=> array('title' => 'CEP', 'help' => 'help_cep2'),
        "END_ENTREGA" 				=> array(),
		"COMPLEMENTO_ENTREGA"		=> array("edit" => "N"),
        "NUMERO_END_ENTREGA" 		=> array('title' => 'NUMERO_ENDERECO'),
        "BAI_ENTREGA" 				=> array('title' => 'BAIRRO'),
        "CIDADE_ENTREGA" 			=> array('autocomplete' => 'Y', 'title' => 'CIDADE', 'alt' => 'alt_desc_cidade'),
        "CEP_ENTREGA" 				=> array('title' => 'CEP', 'help' => 'help_cep'),
        "CEP_ENTREGA1" 				=> array('title' => 'CEP', 'help' => 'help_cep2'),
        "RAMOATIVIDADE" 			=> array(),
        "ID_RADIO" 					=> array('case' => 'NONE'),
        "FONEFAX" 					=> array('validate' => array('Cisweb_Validate_Telefone')),
        "VENDEDOR" 					=> array("grid" => true),
        "VENDEDOR_LOCACAO" 			=> array(),
        "VENDEDOR_PROJETO" 			=> array(),
        "VENDEDOR_LOCACAO_SERV" 	=> array(),
        "DIA_EMISSAO_COBRANCA" 		=> array('VP' => array('1' => '1', '2' => '2', '3' => '3', '4' => '4', '5' => '5', '6' => '6', '7' => '7', '8' => '8', '9' => '9',
                '10' => '10', '11' => '11', '12' => '12', '13' => '13', '14' => '14', '15' => '15', '16' => '16', '17' => '17', '18' => '18',
                '19' => '19', '20' => '20', '21' => '21', '22' => '22', '23' => '23', '24' => '24', '25' => '25', '26' => '26', '27' => '27', '28' => '28', '29' => '29', '30' => '30', '31' => '31')),
        "FORMA_PAGTO_COBRANCA" 		=> array('VP' => array('C' => 'COB_CARTEIRA', 'S' => 'BOLETO_SEMREGISTRO', 'R' => 'BOLETO_COMREGISTRO')),
        "FATURA_NFS" 				=> array('VP' => array('F' => 'FATURA', 'N' => 'nota_fiscal_de_servico')),
        'VENC' 						=> array('NULLABLE' => true, 'editlevel' => 3, "alt" => "alt_desc_venc"),
        "ULTIMO_PROSPEC" 			=> array(),
        "TRANSP" 					=> array('NULLABLE' => false),
        "DIACERTOVENC1" 			=> array(),
        "DIACERTOVENC2" 			=> array(),
        "DIACERTOVENC3" 			=> array(),
        "DIACERTOVENC4" 			=> array(),
        "DIACERTOVENC5" 			=> array(),
        "DIACERTOVENC6" 			=> array(),
        "PROTESTAR" 				=> array('VP' => array('S' => 'SIM', 'N' => 'NAO')),
        "SITUACAO"					=> array('VP' => array('N' => 'normal', 'P' => 'com_problema_de_pagamento')),
		"DATA_CRIACAO" 				=> array("edit" => "N"),
		"FUNC_CRIACAO"				=> array("edit" => "N"),
        "FUNC_ALTERACAO" 			=> array("edit" => "N"),
        "DATA_ALTERACAO" 			=> array("edit" => "N"),
        "DATASINC" 					=> array("edit" => "N"),
        "REVISAO" 					=> array("edit" => "N")
      
    );
    var $_referenceMap    = array(

	'CIDADE' => array(
            'columns'           => 'CIDADE',
            'refTableClass'     => 'core_Model_DbTable_Cidade',
            'refColumns'        => 'ID',
            'refTitle'          => 'CIDADE'
    	),

	'VENDEDOR' => array(
            'columns'           => 'VENDEDOR',
            'refTableClass'     => 'core_Model_DbTable_Usuario',
            'refColumns'        => 'ID',
            'refTitle'          => 'VENDEDOR'
    	),

	'VENDEDOR_LOCACAO' => array(
            'columns'           => 'VENDEDOR_LOCACAO',
            'refTableClass'     => 'core_Model_DbTable_Usuario',
            'refColumns'        => 'ID',
            'refTitle'          => 'VENDEDOR'
    	),

    	'VENC' => array(
            'columns'           => 'VENC',
            'refTableClass'     => 'core_Model_DbTable_Vencimento',
            'refColumns'        => 'ID',
            'refTitle'          => 'VENC'
    	),

        'CIDADE_COB' => array(
            'columns'           => 'CIDADE_COB',
            'refTableClass'     => 'core_Model_DbTable_Cidade',
            'refColumns'        => 'ID',
            'refTitle'          => 'CIDADE_COB'
    	),

        'CIDADE_ENTREGA' => array(
            'columns'           => 'CIDADE_ENTREGA',
            'refTableClass'     => 'core_Model_DbTable_Cidade',
            'refColumns'        => 'ID',
            'refTitle'          => 'CIDADE_ENTREGA'
    	),

    	'RAMOATIVIDADE' => array(
            'columns'           => 'RAMOATIVIDADE',
            'refTableClass'     => 'core_Model_DbTable_Ramoatividade',
            'refColumns'        => 'ID',
            'refTitle'          => 'RAMOATIVIDADE'
    	),

	'FORMA_ABORDAGEM' => array(
            'columns'           => 'FORMA_ABORDAGEM',
            'refTableClass'     => 'core_Model_DbTable_Crmformaabord',
            'refColumns'        => 'ID',
            'refTitle'          => 'FORMA_ABORDAGEM'
    	),

        'TRANSP' => array(
            'columns'           => 'TRANSP',
            'refTableClass'     => 'core_Model_DbTable_Transportadora',
            'refColumns'        => 'CODIGO',
            'refTitle'          => 'TRANSP'
    	),
	
    );

}
?>