<?php

class serv_Model_DbTable_Programaitemreprovado extends Zsam_Db_Table {

	/**
	 * The default table name
	 */

	protected $_name  = 'progritensreprovados';

	var $_autocomplet = array('ITEM_PROGR','NUM_ITEM','PRODUTO');
	
	
	var $_conf = array(
			'CLIENTE' 				=> array('edit' => 'N', 'grid' => true, 'NULLABLE' => false),
			'ITEM_PROGR'			=> array('edit' => 'N'),
			'NUM_ITEM' 				=> array('edit' => 'N', 'grid' => true, 'NULLABLE' => false),
            'ID'					=> array('edit' => 'N'),
			'MOTIVO'				=> array('edit' => 'N', 'grid' => true, 'NULLABLE' => false),
			'REPROVADO'				=> array('edit' => 'N', 'grid' => true, 'NULLABLE' => false, 'title'=>'tipo_reprovacao','help' => 'help_reprovado_ou_declinado'),
			'PERIODO_REPROVACAO' 	=> array('edit' => 'N', 'grid' => true, 'NULLABLE' => false,'title'=>'mes_reprovacao'),   
			'EMPRESA' 				=> array('edit' => 'N', 'grid' => true, 'NULLABLE' => false),
			'PRODUTO' 				=> array('edit' => 'N','autocomplete'=>'Y','NULLABLE' => false),
			'DESCRICAO_ITEM_NOVO'	=> array('edit' => 'N'),//nao esta sendo usado seria para cadastrar item novo
	        'CFOP' 					=> array('edit' => 'N','NULLABLE' => false),
	        'QUANTIDADE' 			=> array('edit' => 'N','NULLABLE' => false),
			'DATANECESSIDADE' 		=> array('edit' => 'N'),
			'PRECO_UNITARIO' 		=> array('edit' => 'N','NULLABLE' => false),
			'PRECO_CUSTO' 			=> array('edit' => 'N','level'=>5),
			'PRECO_BASE' 			=> array('edit' => 'N'),
	        'PRECO_TOTAL_ITEM'		=> array('edit' => 'N'),
			'ESTOQUE'				=> array('title' => 'ESTOQUE_REVENDA','edit' => 'N'),
			'ESTOQUE_LOCACAO_NOVO' 	=> array('edit' => 'N'),
			'ESTOQUE_LOCACAO_USADO'	=> array('edit' => 'N'),
			'RESERVAS_LOCACAO' 		=> array('edit' => 'N','title'=>'pedidos_de_compra'),
			'RESERVAS_REVENDA' 		=> array('edit' => 'N'),
			'BAIXA' 				=> array('edit' => 'N'),
	        'UNI'					=> array('edit' => 'N'),
	        'NCM'					=> array('edit' => 'N'),
	        'STICMS'				=> array('edit' => 'N'),
	        'ORIGEM_SIT_TRIBUTARIA'	=> array('edit' => 'N'),
	        'BASE_DE_CALCULO_ICMS'	=> array('edit' => 'N'),
	        'PERCENTUAL_REDUCAO_BC_ICMS'=> array(),
	        'MODALIDADE_BC_ICMS'	=> array(),
	        'ALIQUOTA_ICMS'			=> array('edit' => 'N'),
	        'TOTAL_ICMS'			=> array('edit' => 'N'),
	        'BASE_DE_CALCULO_ICMS_ST'=> array('edit' => 'N'),
	        'MODALIDADE_BC_ICMSST'	=> array('edit' => 'N'),
	        'ALIQUOTA_ICMS_ST'		=> array('edit' => 'N'),
	        'TOTAL_ICMS_ST'			=> array('edit' => 'N'),
	        'STIPI'					=> array('edit' => 'N'),
	        'BASE_DE_CALCULO_IPI'	=> array('edit' => 'N'),
	        'ALIQUOTA_IPI'			=> array('edit' => 'N'),
	        'TOTAL_IPI'				=> array('edit' => 'N'),
	        'STPIS'					=> array('edit' => 'N'),
	        'BASE_DE_CALCULO_PIS'	=> array('edit' => 'N'),
	        'ALIQUOTA_PIS'			=> array('edit' => 'N'),
	        'TOTAL_PIS'				=> array('edit' => 'N'),
	        'STCOFINS'				=> array('edit' => 'N'),
	        'BASE_DE_CALCULO_COFINS'=> array('edit' => 'N'),
	        'ALIQUOTA_COFINS'		=> array('edit' => 'N'),
	        'TOTAL_COFINS'			=> array('edit' => 'N'),
			'INFORMACAO_ADICIONAL'	=> array('edit' => 'N','help'=>'help_quebrar_linha_com_;'),
	        'FUNC_ALTERACAO' 		=> array('edit' => 'N'),
			'DATA_ALTERACAO' 		=> array('edit' => 'N'),
			'REVISAO' 				=> array('edit' => 'N'),
			'DATASINC' 				=> array('edit' => 'N')
	);
	
	var $_referenceMap = array(
			
			'PRODUTO' => array(
					'columns' 	=> 'PRODUTO',
					'refTitle' 	=> 'DESCRICAO'
			),

			'EMPRESA' => array(
					'columns' 		=> 'EMPRESA',
					'refTableClass' => 'core_Model_DbTable_Empresa',
					'refColumns' 	=> 'CODIGO',
					'refTitle' 		=> 'NOME'
			),

	        'CFOP' => array(
	                'columns' 		=> 'CFOP',
	                'refTableClass' => 'core_Model_DbTable_Cfop',
	                'refColumns' 	=> 'CODIGO',
	                'refTitle' 		=> 'CFOP'
	        )
	);
	public function __construct()
	{
		parent::__construct();

		$controller      = Zend_Controller_Front::getInstance()->getRequest();
		$nome_controller = $controller->getControllerName(); //pegar a controladora


		$cliente = Zend_Registry::get('Cliente');
		if($cliente[0]['IND_COM_SERV'] == "I")
		{
			$this->_referenceMap['PRODUTO']['refTableClass'] = array('table1' => 'ind_Model_DbTable_Produto','table2' => 'ind_Model_DbTable_ProdutoCliente');
			$this->_referenceMap['PRODUTO']['refColumns'] = array('table1' => 'CODIGO','table2' => 'PRODUTO');
		}

		else if($cliente[0]['IND_COM_SERV'] == "C")
		{
			$this->_referenceMap['PRODUTO']['refTableClass'] = array('table1' => 'com_Model_DbTable_Produto','table2' => 'com_Model_DbTable_ProdutoCliente');
			$this->_referenceMap['PRODUTO']['refColumns'] = array('table1' => 'CODIGO','table2' => 'PRODUTO');
		}

		else
		{
			$this->_referenceMap['PRODUTO']['refTableClass'] = 'core_Model_DbTable_Ativoprodutos';
			$this->_referenceMap['PRODUTO']['refColumns'] = 'CODIGO';
		}
	}
}
?>